CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000


  SR_CLOCK        = 0                    { lcd driver }
  SR_LATCH        = 1                    { lcd driver }
  SR_DATA         = 2                    { lcd driver }

  Led_1           = 9                    { Temp Led }
  Led_2           = 10                    { LV Led }
  Led_3           = 11                   { CO2 Led }
  Led_4           = 12                   { Histories Max Led }
  Led_5           = 13                   { Histories Min Led }
  Led_6           = 14                   { Setpoint Day }
  Led_7           = 15                   { Offset }

  ADC_3           = 18                   {ADC control }
  ADC_2           = 17                   {ADC control }
  ADC_1           = 16                   {ADC control }

  SHT_CLK         = 19                   { TEMP/ RV sensor}
  SHT_DATA        = 20                   { TEMP/ RV sensor}

  Relay_3         = 21                   {SSR Control}
  Relay_2         = 22                   {SSR Control}
  Relay_1         = 23                   {SSR Control}

  buton1          = 24                   { push buttons }
  buton2          = 25                   { push buttons }
  buton3          = 26                   { push buttons }
  buton4          = 27                   { push buttons }

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  NULL          = $00

  SOCKETS       = 8
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

    

  Zero_Out = 0                  {valvue to reset historic reading}

  i2cSCL        = 28   
  EEPROMAddr    = %1010_0000
    
    
VAR
  long  seed
  byte templock,notactive

  byte  temp[32]                               {input temp }
  byte  lv[32]                                 {input lv }
  long tempC,tempC1,tempC2,tempC3              {global temp vars }
  long lv1,lv2,lv3                             {global lv vars }

  long tempmax,tempmin       {Historis Min /Max Temp Variabelen }
  long lvmax,lvmin ,eepromData          {Historis Min /Max LV Variabelen }    
  long Setpoint,Offset    
  long stack1[128] ,stack2[128]   {stackspace for new cog }

DAT
  index byte  "HTTP/1.1 200 OK", CR, LF, {
}             "Content-Type: text/html", CR, LF, CR, LF, {
}             "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>", CR, LF, {
}             "<html  xmlns='http://www.w3.org/1999/xhtml'>" , CR, LF, {
}             "<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8' />", CR, LF, {

}             "<meta name='viewport' content='width=device-width, user-scalable=no'>", CR, LF, { 
}             "<meta name='description' content='An ICE Control Production.' >", CR, LF, { 
}             "<title>PX-100D</title>", CR, LF, {

}             "<link rel='stylesheet' href='http://192.168.2.151/test/demo.css' type='text/css' media='screen' />", CR, LF, {
}             "<link rel='stylesheet' href='http://192.168.2.151/test/style2.css' type='text/css' media='screen' />", CR, LF, { 

}             "<link rel='stylesheet' href='http://192.168.2.151/test/style22.css' type='text/css' media='screen' />", CR, LF, { 
}             "<link rel='stylesheet' href='http://192.168.2.151/test/graph-style.css' type='text/css' media='screen' />", CR, LF, {
}             "<script type='text/javascript' src='http://192.168.2.151/test/graph.js'></script>", CR, LF, {

}             "<script type='text/javascript'>" , CR, LF, {

}                       "window.onload = function() {", CR, LF, {
}                       "g_graph = new Graph({", CR, LF, {
}                       "'id': 'firstgraph',", CR, LF, {
}                       "'strokeStyle': '#819C58',", CR, LF, {      
}                       "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}                       "'grid': [5,10],", CR, LF, { 
}                       "'range': [0,40],", CR, LF, { 
}                       "'call': function(){ return ( Math.floor(latestTemp())); }", CR, LF, {
}                       "});", CR, LF, {

}                       "second_graph = new Graph({", CR, LF, {
}                       "'id': 'secondgraph',", CR, LF, {
}                       "'strokeStyle': '#819C58',", CR, LF, {
}                       "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}                       "'grid': [10,20],", CR, LF, { 
}                       "'range': [0,100],", CR, LF, {
}                       "'call': function(){ return ( Math.floor(latestHumidity())); }", CR, LF, {
}                       "});}", CR, LF, {


}                        "setInterval(", $22, "getRequest('xmltemp', 'placeholder')", $22, ", 1000);", CR, LF, {        


}                       "function toggleDraw() { g_graph.toggleDraw(); }", CR, LF, {
}                       "function toggleValue(value) { g_graph.toggleValue(value); }", CR, LF, {
}                       "function setFill(val) { if(val == undefined) val = getRandomRGBA(); g_graph.setValue('fillStyle',val); }", CR, LF, {
}                       "function setColor(val) { if(val == undefined) val = getRandomRGB(); g_graph.setValue('strokeStyle',val); }", CR, LF, {
}                       "function getRandomRGB() { return 'rgb(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ')'; }", CR, LF, {
}                       "function getRandomRGBA() { return 'rgba(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ', ' + '0.25)'; }", CR, LF, {
}                       "function clearGraph() { g_graph.clearGraph(); }", CR, LF, {

}                       "function toggleDrawsecond() { second_graph.toggleDraw(); }", CR, LF, {
}                       "function toggleValuesecond(value) { second_graph.toggleValue(value); }", CR, LF, {
}                       "function setFillsecond(val) { if(val == undefined) val = getRandomRGBAsecond(); second_graph.setValue('fillStyle',val); }", CR, LF, {
}                       "function setColorsecond(val) { if(val == undefined) val = getRandomRGBsecond(); second_graph.setValue('strokeStyle',val); }", CR, LF, {
}                       "function getRandomRGBsecond() { return 'rgb(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ')'; }", CR, LF, {
}                       "function getRandomRGBAsecond() { return 'rgba(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ', ' + '0.25)'; }", CR, LF, {
}                       "function clearGraphsecond() { second_graph.clearGraph(); }", CR, LF, {

}             "</script>", CR, LF, {

}             "<script src='http://192.168.2.151/test/DigitalClock.js'></script>", CR, LF, { 



}             "<header id='headerbar' class='bar'>", CR, LF, { 
}                       "<h1><a href='http://www.ice-control.nl/index.php' target='_blank'>ICE-Control.nl</a></h1>", CR, LF, {
}                       "<p class='copyright'>&copy; 2012</p>", CR, LF, {  
}             "</header>", CR, LF, {      


}             "<div id='logo1'><img src='http://192.168.2.151/test/Logo_website.jpg' alt='logo'  width='100%' height='100%' title='ICE Control Logo'/>", CR, LF, {            
}             "</div>", CR, LF, {



}             "<div id='graph1'>  ", CR, LF, { 
}                       "<article id='post' role='main'>", CR, LF, {     
}                       "<div><canvas id='firstgraph' width='940' height='200'></canvas>", CR, LF, {   
}             "</div>", CR, LF, {         
}             "</div>", CR, LF, { 
  
  
}             "<div id='graph2'>  ", CR, LF, {  
}                       "<article id='post' role='main'>", CR, LF, { 
}                       "<div><canvas id='secondgraph' width='940' height='400'></canvas>", CR, LF, {    
                                                                       
}             "</div>", CR, LF, {   
}             "</div>", CR, LF, {


}             "<div id='graphpanel1'>                                                                                             ", CR, LF, {   
}             "<table>                                                                                                           ", CR, LF, {  
}                       "<tr>                                                                                                    ", CR, LF, {
}                               "<tr> <td rowspan='2'> <div><span id='tmax'></span> C</div> </td></tr>                           ", CR, LF, {    
}                               " <td><div><span id='placeholder'></span> C</div> </td>                                          ", CR, LF, {
}                       "</tr>                                                                                                   ", CR, LF, {    
}                       "<tr>                                                                                                    ", CR, LF, {    
}                               "<td><div><span id='tmin'></span> C</div></td>                                                   ", CR, LF, {
}                       "</tr>                                                                                                   ", CR, LF, {  
}             "</table>                                                                                                          ", CR, LF, {     


 
}             "</div>                                                                                                            ", CR, LF, {                                                                                                                                          
}             "<div id='graphpanel2'>                                                                                            ", CR, LF, {    
}             "<table>                                                                                                           ", CR, LF, {    
}                       "<tr>                                                                                                    ", CR, LF, {
}                               "<tr> <td rowspan='2'> <div><span id='lvmax'></span> %</div> </td></tr>                           ", CR, LF, {    
}                               " <td><div><span id='placeholder2'></span> %</div> </td>                                          ", CR, LF, {
}                       "</tr>                                                                                                   ", CR, LF, {  
}                       "<tr>                                                                                                    ", CR, LF, {    
}                               "<td><div><span id='lvmin'></span> %</div></td>                                                   ", CR, LF, {
}                       "</tr>                                                                                                   ", CR, LF, {  
}             "</table>                                                                                                          ", CR, LF, { 
}             "</div>                                                                                                            ", CR, LF, {



}             "<div id='interface-buttons1'>                                                                                      ", CR, LF, {    
}             "<div><span id='setpoint'></span></div>                                                                             ", CR, LF, {
}             "<div><span id='offset'></span></div>                                                                               ", CR, LF, {                  
}             "</div>                                                                                                             ", CR, LF, {  


}             "<div id='interface-buttons2'>                                                                                      ", CR, LF, {    
}             "<p               >                                                                                                 ", CR, LF, {
}             "<a onclick=", $22, "Setpointmin()", $22,"  class='a_demo_two'>-</a>                                                ", CR, LF, { 
}             "<a onclick=", $22, "SetpointVar()", $22,"  class='a_demo_two'>Setpoint</a>                                         ", CR, LF, {
}             "<a onclick=", $22, "Setpointplus()", $22, "  class='a_demo_two'>+</a></p>                                          ", CR, LF, {                
}             "</div>                                                                                                             ", CR, LF, {                                                  

}             "<div id='interface-buttons3'>                                                                                      ", CR, LF, {    
}             "<p>                                                                                                                ", CR, LF, {
}             "<a onclick=", $22, "offsetmin()", $22,"  class='a_demo_two'>-</a>                                                  ", CR, LF, { 
}             "<a onclick=", $22, "offsetVar()", $22,"  class='a_demo_two' style='padding-left:21px;padding-right:21px;'>Offset</a>                                           ", CR, LF, {
}             "<a onclick=", $22, "offsetplus()", $22, "  class='a_demo_two'>+</a></p>                                            ", CR, LF, {                
}             "</div>                                                                                                             ", CR, LF, { 

}             "<header id='bottom-bar' class='bar1'>", CR, LF, { 
}                       "<canvas id='myCanvas' width='100' height='50'</canvas>", CR, LF, {

}             "</header>", CR, LF, { 
}             "</body>                                                                                                                                  ", CR, LF, {
}             "</html>", 0                


  xml   byte  "HTTP/1.1 200 OK", CR, LF, {
  }           "Content-Type: text/xml", CR, LF, CR, LF, {
  }           "<?xml version='1.0' encoding='utf-8'?><root><temp>"
  temperature  byte  $30, $30, $2E, $30,        "</temp><humidity>"
  lvlv         byte  $30, $30,                      "</humidity><tmax>"
  t_max        byte  $30, $30, $2E, $30,           "</tmax><tmin>"
  t_min        byte  $30, $30, $2E, $30,           "</tmin><lvmax>"
  lv_max       byte  $30, $30,                    "</lvmax><lvmin>"
  lv_min       byte  $30, $30,                    "</lvmin><setpoint>"
  set_p       byte  $30, $30,                    "</setpoint><offset>"
  off_s       byte  $30, $30,                    "</offset></root>", 0
  
  buff  byte  $0[BUFFER_2K]
  resPtr long $0[25]
  
OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5200.spin" 
  sock[SOCKETS]   : "Socket.spin"
  dhcp            : "Dhcp" 
  sht             : "Sensirion_full"         { temp/lv sensor control object }
  fp              : "FloatString"              { Math object }
  f               : "Float32"                  { Math object }
  i2cObject       : "basic_i2c_driver"         {Eprom object}  
 

PUB Main | i, page, dnsServer


  setpoint :=  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7981) 
  offset :=  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7977)   
  
  cognew(Tempcontrol,@stack1)

  pst.Start(115_200)
  pause(1000)

  pst.str(string("Initialize W5200", CR))
  wiz.start(6, 5, 4, 7)
  wiz.SetMac($00, $08, $DC, $16, $F8, $01)

  pst.str(string("Getting network paramters", CR))
  dhcp.Init(@buff, 7)
  pst.str(string("Requesting IP....."))
  ifnot(dhcp.DoDhcp)
    pst.str(string(CR, "Error Code: "))
    pst.dec(dhcp.GetErrorCode)
    pst.char(CR)
    pst.str(dhcp.GetErrorMessage)
    pst.char(CR)
    return
  else
    PrintIp(dhcp.GetIp)

  pst.str(string("DNS..............."))
  dnsServer := wiz.GetDns
  PrintIp(wiz.GetDns)

  pst.str(string("DHCP Server......."))
  printIp(wiz.GetDhcpServerIp)

  pst.str(string("Router IP........."))
  printIp(wiz.GetRouter)
  pst.char(CR)

  repeat
    pst.str(string("Initialize Sockets",CR))
    repeat i from 0 to SOCKETS-1
      sock[i].Init(i, TCP, 8080)
           
    OpenListeners
    StartListners
        
    pst.str(string("Start Socket server",CR))
    \MultiSocketServer
    pst.str(string("I blew up!"))
    pause(5000)


  
PUB OpenListeners | i
  pst.str(string("Open",CR))
  repeat i from 0 to SOCKETS-1  
    sock[i].Open
      
PUB StartListners | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].Listen)
      pst.str(string("Listen "))
    else
      pst.str(string("Listener failed ",CR))
    pst.dec(i)
    pst.char(CR)

PUB CloseWait | i
  repeat i from 0 to SOCKETS-1
   
    if(sock[i].IsCloseWait) 
      sock[i].Disconnect
      sock[i].Close
      
    if(sock[i].IsClosed)  
      sock[i].Open
      sock[i].Listen

PUB MultiSocketServer | bytesToRead, i, page, j, x , bytesSent, ptr
  bytesToRead := bytesSent := i := j := x := 0
  repeat
    pst.str(string("TCP Service", CR))
    CloseWait

    repeat j from 0 to SOCKETS-1
      pst.str(string("Socket "))
      pst.dec(j)
      pst.str(string(" = "))
      pst.hex(wiz.GetSocketStatus(j), 2)
      pst.char(13)
     
    repeat until sock[i].Connected
      i := ++i // SOCKETS

    pst.str(string("Connected Socket "))
    pst.dec(i)
    pst.char(CR)
    
    'Data in the buffer?
    repeat until bytesToRead := sock[i].Available

    'Check for a timeout
    if(bytesToRead < 0)
      pst.str(string("Timeout",CR))
      sock[i].Disconnect
      sock[i].Open
      sock[i].Listen
      bytesToRead~
      next

    pst.str(string("Copy Rx Data",CR))
  
    'Get the Rx buffer  
    sock[i].Receive(@buff, bytesToRead)

    {{ Process the Rx data}}
    pst.char(CR)
    pst.str(string("Request:",CR))
    pst.str(@buff)

    pst.str(string("Send Response",CR))
    page :=  ParseResource(@buff)
    
    pst.str(page)
    pst.char(CR)
    pst.str(string("Byte to send "))
    pst.dec(strsize(page))
    pst.char(CR)

    bytesSent := 0
    ptr := page
    repeat until bytesSent == strsize(page)
      bytesSent += sock[i].Send(ptr, strsize(ptr))
      ptr := page + bytesSent

    pst.str(string("Bytes Sent "))
    pst.dec(bytesSent)
    pst.char(CR)

    pst.str(string("Disconnect socket "))
    pst.dec(i)
    pst.char(CR)

    if(sock[i].Disconnect)
      pst.str(string("Disconnected", CR))
    else
      pst.str(string("Force Close", CR))
    sock[i].Open
    sock[i].Listen
    sock[i].SetSocketIR($FF)
    
    i := ++i // SOCKETS
    bytesToRead~

PUB ParseResource(header) | ptr, value, i, done, j
  ptr := header
  i := 0
  done := false

  repeat until IsEndOfLine(byte[ptr])
    if(IsToken(byte[ptr]))
      byte[ptr] := 0
      resPtr[i++] := ++ptr
    else
      ++ptr

    if(ptr - header > 500)
      pst.str(string(CR, "+++++++++++++++[ERROR]++++++++++++++",CR))
      return @index

  resPtr[0] := header
  repeat j from 0 to i-1
    pst.str(string("ID"))
    pst.dec(j)
    pst.char($20)
    pst.str(resPtr[j])
    pst.char(CR)

  repeat j from 0 to i-1
    if(strcomp(resPtr[j], string("HTTP")))
      return @index

      
    if(strcomp(resPtr[j], string("xmltemp")))
      value := GetTemp
      Settemp(tempc3,@temperature)
      Setlv(lv3,@lvlv)
      Settemp(tempmax,@t_max)
      Settemp(tempmin,@t_min)
      Setlv(lvmax,@lv_max)
      Setlv(lvmin,@lv_min)
      Setlv(setpoint,@Set_p)
      Setlv(offset,@off_s)
      return @xml

    if(strcomp(resPtr[j], string("setpointplus")))
        setpointplus
        return 
    if(strcomp(resPtr[j], string("setpointmin")))
       setpointmin
        return  
    if(strcomp(resPtr[j], string("offsetplus")))
        offsetplus
         return 
    if(strcomp(resPtr[j], string("offsetmin")))
       offsetmin
        return  
            
PUB setpointplus     
 if setpoint < 99
   Setpoint:= Setpoint + 1
 return

 
PUB setpointmin     

 if setpoint > 1
   Setpoint:= Setpoint - 1
 return

PUB offsetplus     
 if offset < 9
   offset:= offset + 1
 return

PUB offsetmin     
 if offset > 1
   offset:= offset - 1
 return  
PUB IsToken(value)
  return lookdown(value: "/", "?", "=", " ")

PUB IsEndOfLine(value)
  return lookdown(value: CR, LF)

PUB GetTemp
  seed := CNT 
  ?seed
  return seed & $0F + 1
  
PUB Settemp(value,plaats) | t1
  t1 := value
  t1 := t1/100
  value -= t1 * 100
  if(t1 > 0 and t1 < 9)
    byte[plaats][0] := t1 + $30
  else
    ResetTemp
    return 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  if(t1 > 0 and t1 < 9) 
    byte[plaats][1] := t1 + $30
  else
    ResetTemp
    return
    
  t1 := value
  if(t1 > 0 and t1 < 9)  
    byte[plaats][3] := t1 + $30
  else
    ResetTemp
    return
    
PUB SetLV(value,plaats) | t1                                              
  t1 := value
 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  'if(t1 > 0 and t1 < 9) 
    byte[plaats][0] := t1 + $30
  'else
    'ResetTemp
    'return
    
  t1 := value
  'if(t1 > 0 and t1 < 9)  
    byte[plaats][1] := t1 + $30
  'else
   ' ResetTemp
    'return
  

PUB ResetTemp
  byte[12] := $30
  byte[13] := $30
  byte[14] := $30  




     
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return
PUB Tempcontrol       | status 

    dira[Relay_1]~~
    templock:=locknew
  
    
    sht.start(SHT_DATA,SHT_CLK)
    f.start
    
    lvmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7997)
    lvmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7993)
    tempmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7989)
    tempmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $7985)
    
  repeat 
    repeat until not lockset(templock)    
      sht.config(33,sht#off,sht#yes,sht#hires)
      tempC := celsius(f.FFloat(sht.readHumidity))
      tempC1 := F.FMul(celsius(f.FFloat(sht.readTemperature)),10.0)     {floating point raw measurement temp}
      tempC2 := fp.FloatToFormat(tempC1, 2, 0)               { string for the display}
      bytemove(@Temp, tempC2, strsize(tempC2) +1)      { copy string }
      tempC3 :=f.FTrunc(tempC1)                              { integer to calculate/use  }
      
     
      lv1 := humidity(tempC, f.FFloat(sht.readHumidity))   {floating poitn ram measurement RH }
      lv2 := fp.FloatToFormat(lv1, 2, 0)                    { string for the display}
      bytemove(@Lv, lv2, strsize(lv2) +1)            { copy string }
      lv3 :=f.FTrunc(lv1)
      lockclr(templock)
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''  

    if tempmin == 0                                    '' max/ min temp geheugen ''
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
           tempmin:=tempC3
                 
    if tempC3 > tempmax
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries" }
          tempmax := tempC3
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $7989, tempC3)
           
    if tempC3 < tempmin
       if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
         tempmin := tempC3   
         i2cObject.WriteLong(i2cSCL, EEPROMAddr, $7985, tempC3)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if lvmin == 0                                    '' max/ min lv geheugen ''
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries } 
           lvmin:=lv3
                 
    if lv3 > lvmax
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }
          lvmax := lv3                                 
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $7997, lv3)
                     
    if lv3 < lvmin
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }  
          lvmin := lv3   
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $7993, lv3) 
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''           
    if lv3 < (setpoint - offset)
           status:=1

    if lv3 > (setpoint + offset)
        status:=0
        

    if status == 1
         outa[Relay_1]~~ 
    else
         outa[Relay_1]~


    waitcnt(clkfreq + cnt)
PUB celsius(t)
  ' from SHT1x/SHT7x datasheet using value for 3.5V supply
  ' celsius = -39.7 + (0.01 * t)
  return f.FAdd(-39.7, f.FMul(0.01, t))  
  
PUB humidity(t, rhh) | rhLinear
  ' rhLinear = -2.0468 + (0.0367 * rh) + (-1.5955E-6 * rh * rh)
  ' simplifies to: rhLinear = ((-1.5955E-6 * rh) + 0.0367) * rh -2.0468
  rhLinear := f.FAdd(f.FMul(f.FAdd(0.0367, f.FMul(-1.5955E-6, rhh)), rhh), -2.0468)
  ' rhTrue = (t - 25.0) * (0.01 + 0.00008 * rawRH) + rhLinear
  return f.FAdd(f.FMul(f.FSub(t, 25.0), f.FAdd(0.01, f.FMul(0.00008, rhh))), rhLinear)